//---------------------------------------------------------------------------

#include <vcl.h>
#include <iterator>
#include "algostuff.hpp"

#include <conio.h> //  getch()

#pragma hdrstop

//---------------------------------------------------------------------------

#pragma argsused
using namespace std;

std::string ToRus(const std::string &in)
{
  char *buff = new char [in.length()+1];
  CharToOem(in.c_str(),buff);
  std::string out(buff);
  delete [] buff;
  return out;
}

int main()
{
 deque<int> coll;

 INSERT_ELEMENTS(coll,1,9);
 cout << ToRus(" :\n");
 PRINT_ELEMENTS(coll);

 //       3
 deque<int>::iterator pos;
 pos = search_n (coll.begin(), coll.end(),    // 
                 4,                           // 
                 3);                          // 

 //  
 if (pos != coll.end()) {
     cout << ToRus("      3 ")
          << ToRus("   ") << distance(coll.begin(),pos) +1
          << "." << endl;
   }
 else {
     cout << ToRus("       3")
          << endl;
   }

 //      ,  3
 pos = search_n (coll.begin(), coll.end(),    // 
                 4,                           // 
                 3,                           // 
                 greater<int>());             // 

 //  
 if (pos != coll.end()) {
     cout << ToRus("   ,    3,\n")
            << ToRus("  ") << distance(coll.begin(),pos) +1
            << ToRus(" .") << endl;
 }
 else {
     cout << ToRus("      ,   3")
          << endl;
 }


  getch();
  return 0;
}

//---------------------------------------------------------------------------